
object List {

  def empty () : List = new ListEmpty()

  def cons (n:Int, L:List) : List = new ListCons(n,L)


  // EMPTY LIST REPRESENTATION
  //
  private class ListEmpty () extends List {

    def isEmpty () : Boolean = true

    def first () : Int = 
      throw new RuntimeException("empty().first()")

    def rest () : List = 
      throw new RuntimeException("empty().rest()")

    def length () : Int = 0

    def append (M:List) : List = M

    def find (f:Int) : Boolean = false

    def isEqual (M:List) : Boolean = M.isEmpty()

    override def equals (other : Any) : Boolean = 
      other match {
	case that : List => this.isEqual(that)
	case _ => false
      }

    override def hashCode () : Int = 41

    override def toString () : String = ""
  }


  // CONS LIST REPRESENTATION
  //
  private class ListCons (n:Int, L:List) extends List {

    def isEmpty () : Boolean = false

    def first () : Int = n

    def rest () : List = L

    def length () : Int = 1 + L.length()

    def append (M:List) : List = List.cons(n,L.append(M))

    def find (f:Int) : Boolean = { (f == n) || L.find(f) }

    def isEqual (M:List) : Boolean = 
      (!(M.isEmpty()) && n==M.first() && L.isEqual(M.rest()))
      override def equals (other : Any) : Boolean = 
	other match {
	  case that : List => this.isEqual(that)
	  case _ => false
	}

    override def hashCode () : Int = 
      41 * (
	41 + n.hashCode()
      ) + L.hashCode()

    override def toString ():String = n + " " + L.toString()
  }
}



abstract class List {

  def isEmpty () : Boolean
  def first () : Int
  def rest () : List
  def length () : Int
  def append (M:List) : List
  def find (f:Int) : Boolean
  def isEqual (M:List) : Boolean

  //  Protected to make it unavailable outside List and its subtypes 
  //  Removed for now
  // protected def toStringLst () : String   
}
